

; =============================================================================================
.NOLIST
include masm32rt.inc
include macro.inc
.const
; =========== Prototypes ===========

FrameProc         PROTO :DWORD,:DWORD,:DWORD,:DWORD
ChildProc       	PROTO :DWORD,:DWORD,:DWORD,:DWORD
CreateFrame     	PROTO 
InitInstance    	PROTO :DWORD
Waiting_Loop  	PROTO
CreateClient 	PROTO :DWORD
CreateMdiChild 	PROTO
Retrieve_Error_Msg PROTO :DWORD

; =========== Equates ===========

IDI_ICON                 EQU 100
IDI_ICON1                EQU 101
IDM_MAINMENU             EQU 543
IDM_FILENEW              EQU 544   ;= WM_MDICREATE
IDM_FILEARRANGE_TILEHORZ EQU 548   ;= WM_MDITILE - 2
IDM_FILEARRANGE_TILEVERT EQU 549   ;= WM_MDITILE - 1
IDM_FILEARRANGE_CASCADE  EQU 551   ;= WM_MDICASCADE
IDM_FILEARRANGE_ICONS    EQU 552   ;= WM_MDIICONARRANGE
IDM_FILEEXIT             EQU 545
IDA_ACC                  EQU 999
IDW_FIRSTCHILD           EQU 1000
; =========== Initialized Data ===========

	.DATA	
InitCtrls INITCOMMONCONTROLSEX <>
nChildCount   dd 0

szFrameTitle  db 'Small MDI',0
szChildTitle  db 'Untitled',0
szFrameClass  db 'Frame Mdi',0
mdiclient db 'MDICLIENT',0
szChildClass  db 'Machin Truc',0

Hclient       dd 0
hMenu         dd 0
hAccel        dd 0
hInstance     dd 0
hwndFrame     dd 0

; =========== Code ============================================================================

	.CODE


FrameProc PROC  uses ebx  hwnd:DWORD, uMsg, wParam, lParam

	.if uMsg == WM_COMMAND
		HIWORD wParam		;edx events of controls
		mov edx,eax			;
		LOWORD wParam		;IDentificateurs de  commandes eax
		mov ebx,lParam		; handle du controle

		.if  eax == IDM_FILEEXIT
			INVOKE  SendMessage,hwnd,WM_CLOSE,0,0
			xor eax,eax 						
		.elseif eax == IDM_FILENEW
			invoke CreateMdiChild		
			xor eax,eax 								
		.elseif eax == IDM_FILEARRANGE_ICONS
			invoke SendMessage,Hclient,WM_MDIICONARRANGE,0,0		
			xor eax,eax 								
		.elseif eax == MDITILE_SKIPDISABLED or MDITILE_ZORDER
			invoke SendMessage,Hclient,WM_MDITILE,MDITILE_SKIPDISABLED,0
			xor eax,eax 								
		.elseif eax == IDM_FILEARRANGE_CASCADE
            	invoke SendMessage,Hclient,WM_MDICASCADE,0,0		
			xor eax,eax 								
		.elseif eax == IDM_FILEARRANGE_TILEVERT
            	invoke SendMessage,Hclient,WM_MDITILE,MDITILE_VERTICAL,0					
			xor eax,eax 								
		.elseif eax == IDM_FILEARRANGE_TILEHORZ
            	invoke SendMessage,Hclient,WM_MDITILE,MDITILE_HORIZONTAL,0		
			xor eax,eax 
		.endif								
	.elseif uMsg == WM_DESTROY
		INVOKE  PostQuitMessage,NULL			
	.elseif uMsg == WM_CREATE
		mov eax,hwnd
		;mov hwndFrame,eax
		invoke CreateClient,hwnd		
		mov eax,0
	.else
		INVOKE  DefFrameProc,hwnd,Hclient,uMsg, wParam, lParam		
	.endif
	ret
FrameProc ENDP
	



; =============================================================================================


MDIChildWndProc PROC    hwnd:DWORD, uMsg, wParam, lParam

; =========== Child Window Proc ===========
	.if uMsg == WM_CREATE
		inc nChildCount
	.elseif uMsg == WM_CLOSE
		dec nChildCount
		invoke DestroyWindow,hwnd
	.else
		invoke DefMDIChildProc,hwnd,uMsg, wParam, lParam
	.endif

	ret
MDIChildWndProc ENDP


;################################################################
CreateFrame PROC 
		Local wca:WNDCLASSEX
		Local  retour:DWORD
		ZEROLOCALES retour
	mov retour,0

	;Register the frame window class. 
	mov wca.cbSize,sizeof WNDCLASSEX
	mov wca.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov wca.lpfnWndProc,FrameProc 
	mov eax,hInstance
	mov wca.hInstance,eax 
	invoke LoadIcon,hInstance,IDI_ICON
	mov wca.hIcon,eax  
	mov wca.hIconSm,eax		
	invoke LoadCursor, NULL, IDC_ARROW
	mov wca.hCursor,eax  
	mov wca.hbrBackground,NULL ;COLOR_APPWORKSPACE + 1  stop Flickering
	mov wca.lpszMenuName,IDM_MAINMENU
	mov wca.lpszClassName,offset szFrameClass 

	invoke RegisterClassEx,addr wca
	.if eax == 0
		jmp FindeCreateFrame
	.endif
	
	; Register the MDI child window class. 

	mov wca.lpfnWndProc,MDIChildWndProc
	mov wca.lpszMenuName,NULL
	mov wca.cbWndExtra,32 ;CBWNDEXTRA local buffer for the window,use setprop instead
	mov wca.lpszClassName,offset  szChildClass
	mov wca.hbrBackground,COLOR_BTNFACE+1	
	invoke LoadIcon,hInstance,IDI_ICON1
	mov wca.hIcon,eax  	
	mov wca.hIconSm,0
	
	invoke RegisterClassEx,addr wca
	.if eax == 0
		jmp FindeCreateFrame
	.endif

	
	INVOKE     CreateWindowEx,WS_EX_LEFT,ADDR szFrameClass,ADDR szFrameTitle,WS_OVERLAPPEDWINDOW,\
				CW_USEDEFAULT,SW_SHOWNORMAL,400,400, NULL, NULL,hInstance, NULL	
	mov retour,eax
	mov hwndFrame,eax
	.if eax != 0
		INVOKE     ShowWindow,hwndFrame, SW_SHOWNORMAL 		
		INVOKE     UpdateWindow,hwndFrame					
	.endif
	;INVOKE  SendMessage,Hclient,WM_MDICREATE,NULL,addr mcs
	INVOKE  LoadAccelerators,hInstance,IDA_ACC
	mov 	hAccel,eax
		
FindeCreateFrame:
	mov eax,retour
	ret
CreateFrame endp

; ########################################################################
;################################################################

CreateClient PROC hwnd:DWORD
	Local ccs:CLIENTCREATESTRUCT
	Local  retour:DWORD
	mov retour,0

	; Retrieve the handle to the window menu and assign the 
	; first child window identifier. 
	invoke GetMenu,hwnd
	mov edx,eax
	invoke GetSubMenu,edx,0 ;WINDOWMENU
	mov ccs.hWindowMenu,eax  	
	mov ccs.idFirstChild,1000 ;IDM_WINDOWCHILD; 

	; Create the MDI client window. 

	invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr mdiclient,NULL, 
		WS_CHILD or WS_CLIPCHILDREN or WS_VSCROLL or WS_HSCROLL or WS_VISIBLE, 
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT, hwnd, 0, hInstance,addr ccs
	mov Hclient,eax
	;invoke ShowWindow,Hclient, SW_SHOW 

FindeCreateClient:
	mov eax,retour
	ret
CreateClient endp

;################################################################

CreateMdiChild proc

	LOCAL mdihWnd :DWORD
	LOCAL Rct     :RECT
	invoke GetClientRect,hwndFrame,ADDR Rct
	sub Rct.right, 24
	sub Rct.bottom, 75
	szText mdiTitle,"Untitled"
	; INVOKE  SendMessage,Hclient,WM_MDICREATE,NULL,offset mcs
	invoke CreateWindowEx,WS_EX_MDICHILD,addr szChildClass,	ADDR mdiTitle,
			MDIS_ALLCHILDSTYLES,10,10,Rct.right,Rct.bottom,
			Hclient,NULL,hInstance,0
	.if eax == 0
		invoke Retrieve_Error_Msg,SADR("CreateMdiChild")
		;the function give useful informations here (National language)
	.endif
	mov mdihWnd, eax
	invoke ShowWindow,mdihWnd,SW_SHOW
	ret

CreateMdiChild endp


InitInstance PROC  init:DWORD 
	Local  retour:DWORD
	mov retour,1
	.if init == 1
		invoke GetModuleHandle,NULL
		mov hInstance,eax	
		;invoke CoInitializeEx,NULL, COINIT_APARTMENTTHREADED OR COINIT_DISABLE_OLE1DDE
		;-------------------------------------------------------------------------------		
		;invoke CoInitializeEx ,NULL, COINIT_APARTMENTTHREADED ;COINIT_MULTITHREADED  ;Thread 3		
		;invoke OleInitialize,NULL
		;invoke LoadLibrary,addr PathDll
		;mov InitCtrls.dwSize,sizeof INITCOMMONCONTROLSEX
		;mov InitCtrls.dwICC, 0 ;remplacer 0 par un identifiant
		;invoke InitCommonControlsEx,addr InitCtrls ;cumulatif
		;Each new control can call the function InitCommonControlsEx
	.else
		;rien
		;invoke OleUninitialize
		;invoke CoUninitialize	
		;invoke FreeLibrary,Hmodule	
	.endif

FindeInitInstance:
	mov eax,retour
	ret
InitInstance endp

	
;################################################################
Waiting_Loop PROC 
			local msg:MSG
	@@:
	INVOKE     GetMessage, addr msg, NULL, 0, 0
	.if eax == 1         ;No one Error accepted here ,save some crash
	;------- vrifier MDI message -------------------------
			invoke TranslateMDISysAccel,Hclient,addr msg 
			.if eax == 0
				invoke TranslateAccelerator,hwndFrame, hAccel, addr msg
				.if eax == 0
					;--- boucle normale ----------
					INVOKE     TranslateMessage, addr msg           ;prend le message
					INVOKE     DispatchMessageA , addr msg          ;envoi les messages aux fentres
				.endif
			.endif
		jmp @B
	.endif
FindeWaiting_Loop:
	mov eax,msg.wParam
	ret
Waiting_Loop endp

;- Error msg in all language	
Retrieve_Error_Msg proc lpTitle:DWORD
	LOCAL lpMsgBuffer 	: DWORD
	
	; calculate language ID, asm version of MAKELANGID
	mov cx, SUBLANG_DEFAULT
	shl ecx, 10
	;or  cx, LANG_NEUTRAL		; LANG_NEUTRAL = 0, nothing necessary
	
	; Setup parameters for FormatMessage, normal pushing to use some
	; params directly (e.g. GetLastError returns the ID in eax, but I
	; can't use this register in "invoke")
	
	push NULL					; we don't need this
	push 0						; min. size of output buffer if we use 
							; FORMAT_MESSAGE_ALLOCATE_BUFFER
	lea  eax, lpMsgBuffer 		; get address of our buffer
	push eax					; address of buffer
	push ecx					; our language ID, calculated above
	invoke GetLastError			; get error number
	push eax					; push return value = error ID
	push NULL					; can be used to format a string, we don't need it
	mov edx, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM
	push edx					; some flags, check your doc for more
	call FormatMessage			; here we go
	
	; Display error-message
	invoke MessageBox, NULL, lpMsgBuffer, lpTitle, MB_OK or MB_ICONSTOP
	
	; free memory
	invoke LocalFree, lpMsgBuffer
	ret
Retrieve_Error_Msg endp	
; =============================================================================================

start:
	invoke InitInstance,1
	invoke CreateFrame
	invoke Waiting_Loop		
	invoke InitInstance,0       
	invoke     ExitProcess,0


; =============================================================================================
END start    

