		

	HIWORD MACRO ParamFen
		mov eax,ParamFen
		shr eax,16
	ENDM
	LOWORD MACRO ParamFen
		mov eax,ParamFen
		and eax,0FFFFh
	ENDM

      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

      PuPo MACRO M1, M2
        push M2
        pop  M1
      ENDM


	InsTxt MACRO Name, Text:VARARG
	LOCAL lbl
		jmp lbl
		Name db Text,0
	lbl:
	ENDM

	return MACRO valeur
		mov eax,valeur
		ret
	ENDM
	
	ZEROLOCALES MACRO dernierelocale:REQ
		mov eax, esp
		mov esp, ebp	; base page of calling procedure
		@@:
		push 0
		cmp esp, eax
		ja @B	
	ENDM	

    ; --------------------------------------------------------
    ; Cre une donne en data,renvoie l'tiquette de la chaine
    ; La cration du nom de l'tiquette est facultatif
    ; la macro vrifie la syntaxe des chaines et tiquettes
    ; ---------------------------------------------------------
      CREDATA MACRO quoted_text:REQ,NomdeChaine
		LOCAL Local_Etiquette,verif
	IFNB <NomdeChaine>			;present
		verif SUBSTR <NomdeChaine>,1,1
      		IFIDN verif,<">            ;si le premier caractere est "
			.ERR  <ETIQUETTE SUPRIMER les " >			
		ENDIF
	Local_Etiquette TEXTEQU <NomdeChaine>		;changer le nom d'tiquette
	ENDIF
	verif SUBSTR <quoted_text>,1,1				
	IFDIF verif,<">
		.ERR  <CHAINE AJOUTER LES " >
	ENDIF
	
		.data
		Local_Etiquette db quoted_text,0
		.code
		EXITM <Local_Etiquette>
      ENDM
    ; ----------------------------------------------------
    ; Sort l' adresse de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
    ; ----------------------------------------------------
    ; Sort l' adresse de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
	;si la chaine est "!DefaultToc",vite que "!" ne devienne un oprateur
	;l'espace aprs ADDR et offset est indispensable
	SADR MACRO quoted_text:REQ,NomdeChaine
           EXITM @CatStr(<ADDR >, CREDATA(quoted_text,NomdeChaine))
      ENDM
    ; ----------------------------------------------------
    ; Sort l' offset de la chaine crer, SOFF("chaine")
    ; -----------------------------------------------------
	SOFF MACRO quoted_text:REQ,NomdeChaine
        	EXITM @CatStr(<Offset >, CREDATA(quoted_text,NomdeChaine))
      ENDM	

  ; ---------------------------------------------------
  ; return an arguments specified in "num" from a macro
  ; argument list or "-1" if the number is out of range
  ; ---------------------------------------------------
    getarg MACRO num:REQ,args:VARARG
      LOCAL cnt, txt
      cnt = 0
      FOR arg, <args>
        cnt = cnt + 1
        IF cnt EQ num
          txt TEXTEQU <arg>     ;; set "txt" to content of arg num
          EXITM
        ENDIF
      ENDM
      IFNDEF txt
        txt TEXTEQU <-1>        ;; return -1 if num out of range
      ENDIF
      EXITM txt
    ENDM
	
  ; -----------------------------------------------
  ; count the number of arguments passed to a macro
  ; This is a slightly modified 1990 MASM 6.0 macro
  ; -----------------------------------------------
    argcount MACRO args:VARARG
      LOCAL cnt
      cnt = 0
      FOR item, <args>
        cnt = cnt + 1
      ENDM
      EXITM %cnt                ;; return as a number
    ENDM		
;la macro peut s'crire plus simplement
;mais hlas,la boucle FOR ... gnre un "internal error" lorsque le fichier inclus
;contient des macros,les macros argcount et getarg sont la pour y remdier
LIB  MACRO args:VARARG
	LOCAL acnt,buffer,var,boucle,buf1
	acnt = argcount(args)			;macro argcount , nb d'arguments
	var = 1
	:boucle
	buffer equ getarg(var,args)		;macro getarg

	buf1 CATSTR <include \masm32\include\>,buffer,<.inc>
	buf1

	buf1 CATSTR <includelib \masm32\lib\>,buffer,<.lib>
	buf1

	var = var + 1
	IF var LE acnt
	goto boucle
	ENDIF
ENDM

; macros d'cran

;HAUTEUR et LARGEUR permettent d'extraire ces dimensions d'une structure rectangle (RECT)

	;usage	 mov resultat,HAUTEUR( Rct)
	HAUTEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).bottom                 ; y bas origine coin haut gauche 0,0
		sub     eax,(RECT ptr [ebx]).top	  			; y haut	
		pop ebx
	EXITM <eax>
	ENDM
	LARGEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).right       ; x coin droit bas  origine coin haut gauche 0,0
		sub     eax, (RECT ptr [ebx]).left      ; x coin gauche haut 
		pop ebx
	EXITM <eax>
	ENDM
	comment 
	
	FRECT	STRUCT
		min POINT <>
		max POINT <>
	FRECT ENDS
	
;la dfinition de la structure RECT est  jeter aux oubliettes 
;dans .data     rect FRECT <>
;dans le code (pseudo code)
;	largeur = rect.max.x -rect.min.x
;     	hauteur = rect.max.y - rect.min.y
;Reference de tailles pour MoveWindow et CreateWindowEx,dans l'ordre
;	rect.min.x,rect.min.y,largeur,hauteur
;Facile!? me direz-vous,essayez maintenant de faire la mme chose avec RECT sans
;regarder winhelp.Je parie que vous n'y arrivez pas,ou alors vous la connaissez par coeur et ne vrifiez pas
;vos sources
;RECT est une blague de chez microsoft
	

